/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2008 University of Washington
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __IPV4_ADDRESS_HELPER_H__
#define __IPV4_ADDRESS_HELPER_H__

#include "helper.h"
#include "ns3/ipv4-address-maker.h"

namespace ns3 {

/**
 * \ingroup Topology
 *
 * \section Ipv4AddressHelper
 *
 * A network has a addresses.
 */

class Ipv4AddressHelper : public AddressHelper
{
public:
  Ipv4AddressHelper (Ipv4AddressMaker &ip);
  virtual ~Ipv4AddressHelper ();

  virtual void AssignAddress (Ptr<NetDevice> device);
  virtual void PreInstall (void);

protected:
  Ipv4AddressMaker *m_ip;
};

} // namespace ns3

#endif //__IPV4_ADDRESS_HELPER_H__

