/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2008 University of Washington
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __IPV4_ADDRESS_ALLOCATOR_H__
#define __IPV4_ADDRESS_ALLOCATOR_H__

#include "ns3/object.h"
#include "ns3/ipv4-address.h"

namespace ns3 {

/**
 * \ingroup Topology
 *
 * \section Ipv4AddressAllocator
 *
 * A network has a addresses.
 */

class Ipv4AddressAllocator : public Object
{
public:
  static TypeId GetTypeId (void);

  Ipv4AddressAllocator ();
  virtual ~Ipv4AddressAllocator ();

  void Init (Ipv4Address prefix, Ipv4Mask mask, Ipv4Address base);
  Ipv4Address GetNetwork (void);
  Ipv4Address AllocateNetwork (void);
  Ipv4Address AllocateNetwork (Ipv4Address base);
  Ipv4Address AllocateAddress (void);
  Ipv4Address GetAddress (void);
  Ipv4Mask GetMask (void);

private:
  Ipv4Address m_prefix;
  Ipv4Mask m_mask;
  Ipv4Address m_base;
};

} // namespace ns3

#endif //__IPV4_ADDRESS_ALLOCATOR_H__

