/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2008 University of Washington
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "ns3/log.h"
#include "adhoc-wifi-netdevice-manager.h"
#include "ipv4-address-manager.h"
#include "ipv4-protocol-manager.h"
#include "ipv4-adhoc-wifi-network-manager.h"

NS_LOG_COMPONENT_DEFINE ("Ipv4AdhocWifiNetworkManager");

namespace ns3 {

NS_OBJECT_ENSURE_REGISTERED (Ipv4AdhocWifiNetworkManager);

  TypeId 
Ipv4AdhocWifiNetworkManager::GetTypeId (void)
{
  static TypeId tid = TypeId ("Ipv4AdhocWifiNetworkManager")
    .SetParent<NetDeviceManager> ();

  return tid;
}

Ipv4AdhocWifiNetworkManager::Ipv4AdhocWifiNetworkManager (
  Ptr<Ipv4AddressAllocator> ip)
{
  NS_LOG_FUNCTION;
  SetNetDeviceManager (CreateObject<AdhocWifiNetDeviceManager> ());
  SetProtocolManager (CreateObject<Ipv4ProtocolManager> ());
  SetAddressManager (CreateObject<Ipv4AddressManager> (ip));
}

Ipv4AdhocWifiNetworkManager::~Ipv4AdhocWifiNetworkManager ()
{
  NS_LOG_FUNCTION;
}

} // namespace ns3
